diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/ClassPreloadService.java trunk/org/jboss/mx/loading/ClassPreloadService.java
--- 6.0.0.M1/org/jboss/mx/loading/ClassPreloadService.java	2009-11-30 14:38:49.000000000 -0600
+++ trunk/org/jboss/mx/loading/ClassPreloadService.java	2009-12-10 12:42:46.000000000 -0600
@@ -72,7 +72,7 @@
    </mbean>
 
  @author Scott.Stark@jboss.org
- @version $Revision: 81022 $
+ @version $Revision: 85671 $
  */
 public class ClassPreloadService
 {
@@ -155,7 +155,7 @@
                   String cname = name.replace('/', '.').substring(0, length - 6);
                   try
                   {
-                     Class c = loader.loadClass(cname);
+                     loader.loadClass(cname);
                      loadedClasses ++;
                      if (trace)
                         log.trace("loaded class: " + cname);
@@ -179,6 +179,7 @@
       log.info("Loaded "+loadedClasses+" classes, "+loadErrors+" CNFEs");
    }
 
+   @SuppressWarnings("unchecked")
    public Pattern[] compileIncludes()
    {
       ArrayList tmp = new ArrayList();
@@ -193,6 +194,7 @@
       tmp.toArray(includes);
       return includes;
    }
+   @SuppressWarnings("unchecked")
    public Pattern[] compileExcludes()
    {
       ArrayList tmp = new ArrayList();
@@ -208,6 +210,7 @@
       return includes;
    }
 
+   @SuppressWarnings("unchecked")
    public URL[] filterCP(URL[] rawCP, Pattern[] includes, Pattern[] excludes)
    {
       if( trace )
diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/ClassToStringAction.java trunk/org/jboss/mx/loading/ClassToStringAction.java
--- 6.0.0.M1/org/jboss/mx/loading/ClassToStringAction.java	2009-11-30 14:31:25.000000000 -0600
+++ trunk/org/jboss/mx/loading/ClassToStringAction.java	2009-12-10 12:42:46.000000000 -0600
@@ -28,14 +28,14 @@
 /** An encapsulation creating a to string rep for a class using a
  * PrivilegedAction for getting the ProtectionDomain.
  * 
- * @version $Revision: 81019 $
+ * @version $Revision: 86129 $
  * @author Scott.Stark@jboss.org
  */
-class ClassToStringAction implements PrivilegedAction
+class ClassToStringAction implements PrivilegedAction<Object>
 {
    private StringBuffer buffer;
-   private Class clazz;
-   ClassToStringAction(Class clazz, StringBuffer buffer)
+   private Class<?> clazz;
+   ClassToStringAction(Class<?> clazz, StringBuffer buffer)
    {
       this.clazz = clazz;
       this.buffer = buffer;
@@ -56,13 +56,13 @@
       return null;
    }
 
-   static void toString(Class clazz, StringBuffer buffer)
+   static void toString(Class<?> clazz, StringBuffer buffer)
    {
-      PrivilegedAction action = new ClassToStringAction(clazz, buffer);
+      ClassToStringAction action = new ClassToStringAction(clazz, buffer);
       AccessController.doPrivileged(action);
    }
 
-   static class SysPropertyAction implements PrivilegedAction
+   static class SysPropertyAction implements PrivilegedAction<String>
    {
       private String key;
       private String def;
@@ -71,15 +71,15 @@
          this.key = key;
          this.def = def;
       }
-      public Object run()
+      public String run()
       {
          return System.getProperty(key, def);
       }
    }
    static String getProperty(String key, String def)
    {
-      PrivilegedAction action = new SysPropertyAction(key, def);
-      String value = (String) AccessController.doPrivileged(action);
+      SysPropertyAction action = new SysPropertyAction(key, def);
+      String value = AccessController.doPrivileged(action);
       return value;
    }
 }
diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/HeirarchicalLoaderRepository3.java trunk/org/jboss/mx/loading/HeirarchicalLoaderRepository3.java
--- 6.0.0.M1/org/jboss/mx/loading/HeirarchicalLoaderRepository3.java	2009-11-30 14:38:49.000000000 -0600
+++ trunk/org/jboss/mx/loading/HeirarchicalLoaderRepository3.java	2009-12-10 12:42:46.000000000 -0600
@@ -43,7 +43,7 @@
  * first and then the parent depending on the java2ParentDelegation flag.
  *
  * @author Scott.Stark@jboss.org
- * @version $Revision: 81022 $
+ * @version $Revision: 85671 $
  */
 public class HeirarchicalLoaderRepository3 extends UnifiedLoaderRepository3
 {
@@ -62,7 +62,7 @@
       /** Override to always return null to force the UCL to only load from
        * its URLs.
        * @param name
-       * @return
+       * @return the url
        */
       public URL getResource(String name)
       {
@@ -75,7 +75,7 @@
        * @return nothing
        * @throws ClassNotFoundException always
        */ 
-      protected synchronized Class loadClass(String name, boolean resolve)
+      protected synchronized Class<?> loadClass(String name, boolean resolve)
             throws ClassNotFoundException
       {
          throw new ClassNotFoundException("NoParentClassLoader has no classes");
@@ -83,26 +83,26 @@
       /** Override to always throw a CNFE to force the UCL to only load from
        * its URLs.
        * @param name
-       * @return
+       * @return the class
        * @throws ClassNotFoundException
        */ 
-      protected Class findClass(String name) throws ClassNotFoundException
+      protected Class<?> findClass(String name) throws ClassNotFoundException
       {
          throw new ClassNotFoundException("NoParentClassLoader has no classes");
       }
    }
    static class CacheClassLoader extends UnifiedClassLoader3
    {
-      Class cacheClass;
-      CacheClassLoader(Class cacheClass, LoaderRepository rep)
+      Class<?> cacheClass;
+      CacheClassLoader(Class<?> cacheClass, LoaderRepository rep)
       {
          super(null, null, new NoParentClassLoader(), rep);
          this.cacheClass = cacheClass;
       }
 
-      protected Class findClass(String name) throws ClassNotFoundException
+      protected Class<?> findClass(String name) throws ClassNotFoundException
       {
-         Class c = cacheClass;
+         Class<?> c = cacheClass;
          if( name.equals(cacheClass.getName()) == false )
             c = null;
          return c;
@@ -246,10 +246,10 @@
     * @return The loaded class
     * @throws ClassNotFoundException If the class could not be found.
     */
-   public Class loadClass(String name, boolean resolve, ClassLoader scl)
+   public Class<?> loadClass(String name, boolean resolve, ClassLoader scl)
       throws ClassNotFoundException
    {
-      Class foundClass = null;
+      Class<?> foundClass = null;
 
       if( java2ParentDelegation == true )
       {
@@ -298,9 +298,9 @@
     * @param classname
     * @return the cached class if found, null otherwise
     */ 
-   public Class getCachedClass(String classname)
+   public Class<?> getCachedClass(String classname)
    {
-      Class clazz = null;
+      Class<?> clazz = null;
       if( java2ParentDelegation == true )
       {
          // Try the parent repository
@@ -365,7 +365,7 @@
     * @param cl the requesting class loader
     * @param urls a list into which the located resource URLs will be placed
     */
-   public void getResources(String name, ClassLoader cl, List urls)
+   public void getResources(String name, ClassLoader cl, List<URL> urls)
    {
       if( java2ParentDelegation == true )
       {
@@ -401,9 +401,9 @@
     * first to this repository and then the parent repository.
     *@return the cached class if found, null otherwise
     */
-   public Class loadClassFromCache(String name)
+   public Class<?> loadClassFromCache(String name)
    {
-      Class foundClass = null;
+      Class<?> foundClass = null;
 
       if( java2ParentDelegation == true )
       {
@@ -429,7 +429,8 @@
     * the parent repository pkg class loaders
     *@return Set<PkgClassLoader>
     */
-   public Set getPackageClassLoaders(String name)
+   @SuppressWarnings("unchecked")
+   public Set<ClassLoader> getPackageClassLoaders(String name)
    {
       Set pkgSet = super.getPackageClassLoaders(name);
       Set parentPkgSet = parentRepository.getPackageClassLoaders(name);
@@ -483,6 +483,7 @@
       return resource;
    }
 
+   @SuppressWarnings("unchecked")
    private class GetClassLoadersAction implements PrivilegedAction
    {
       private String name;
diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/LoaderRepositoryFactory.java trunk/org/jboss/mx/loading/LoaderRepositoryFactory.java
--- 6.0.0.M1/org/jboss/mx/loading/LoaderRepositoryFactory.java	2009-11-30 14:31:25.000000000 -0600
+++ trunk/org/jboss/mx/loading/LoaderRepositoryFactory.java	2009-12-10 12:42:46.000000000 -0600
@@ -43,7 +43,7 @@
  *
  * @author <a href="mailto:d_jencks@users.sourceforge.net">David Jencks</a>
  * @author Scott.Stark@jboss.org
- * @version $Revision: 81019 $
+ * @version $Revision: 86129 $
  */
 public class LoaderRepositoryFactory
 {
@@ -51,7 +51,7 @@
    public static ObjectName DEFAULT_LOADER_REPOSITORY;
    private static Logger log = Logger.getLogger(LoaderRepositoryFactory.class);
    /** A HashMap<ObjectName, Integer> for the active references to LoaderRepositorys */
-   private static HashMap referenceCountMap = new HashMap();
+   private static HashMap<ObjectName, Integer> referenceCountMap = new HashMap<ObjectName, Integer>();
 
    static
    {
@@ -117,6 +117,7 @@
     create a LoaderRepositoryConfig representation.
     @param config the xml loader-repository element
     @return a LoaderRepositoryConfig representation of the config
+    @throws MalformedObjectNameException for a bad object name
     */
    public static LoaderRepositoryConfig parseRepositoryConfig(Element config)
       throws MalformedObjectNameException
@@ -225,9 +226,9 @@
          try
          {
             // Create the repository loader
-            Class repositoryClass = loader.loadClass(repositoryClassName);
-            Class[] ctorSig = {MBeanServer.class, ObjectName.class};
-            Constructor ctor = repositoryClass.getConstructor(ctorSig);
+            Class<?> repositoryClass = loader.loadClass(repositoryClassName);
+            Class<?>[] ctorSig = {MBeanServer.class, ObjectName.class};
+            Constructor<?> ctor = repositoryClass.getConstructor(ctorSig);
             Object[] args = {server, DEFAULT_LOADER_REPOSITORY};
             repository = (LoaderRepository) ctor.newInstance(args);
             server.registerMBean(repository, repositoryName);
@@ -243,7 +244,7 @@
             // Configure the repository
             if( config.configParserClassName != null && config.repositoryConfig != null )
             {
-               Class parserClass = loader.loadClass(config.configParserClassName);
+               Class<?> parserClass = loader.loadClass(config.configParserClassName);
                LoaderRepositoryConfigParser parser = (LoaderRepositoryConfigParser)
                   parserClass.newInstance();
                parser.configure(repository, config.repositoryConfig);
@@ -256,7 +257,7 @@
          }
       } // end of try-catch
 
-      Integer activeCount = (Integer) referenceCountMap.get(repositoryName);
+      Integer activeCount = referenceCountMap.get(repositoryName);
       if( activeCount == null )
          activeCount = new Integer(1);
       else
@@ -271,7 +272,7 @@
       {
          try
          {
-            Integer activeCount = (Integer) referenceCountMap.get(repositoryName);
+            Integer activeCount = referenceCountMap.get(repositoryName);
             if( activeCount != null )
             {
                if( activeCount.intValue() == 1 )
diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/LoaderRepository.java trunk/org/jboss/mx/loading/LoaderRepository.java
--- 6.0.0.M1/org/jboss/mx/loading/LoaderRepository.java	2009-11-30 14:31:25.000000000 -0600
+++ trunk/org/jboss/mx/loading/LoaderRepository.java	2009-12-10 12:42:46.000000000 -0600
@@ -21,7 +21,6 @@
  */
 package org.jboss.mx.loading;
 
-import EDU.oswego.cs.dl.util.concurrent.ConcurrentReaderHashMap;
 import org.jboss.logging.Logger;
 import org.jboss.mx.server.ServerConstants;
 import org.jboss.util.loading.Translator;
@@ -31,34 +30,33 @@
 import java.util.HashMap;
 import java.util.List;
 import java.util.Vector;
+import java.util.concurrent.ConcurrentHashMap;
 
 /**
  * Abstract base class of all loader repository implementations
  * 
- * @see org.jboss.mx.loading.BasicLoaderRepository
- *
  * @author  <a href="mailto:juha@jboss.org">Juha Lindfors</a>.
- * @version $Revision: 81019 $
+ * @version $Revision: 86129 $
  */
 public abstract class LoaderRepository
    implements ServerConstants, ClassLoaderRepository
 {
 
    // Attributes ----------------------------------------------------
-   protected static Vector loaders = new Vector();
+   protected static Vector<ClassLoader> loaders = new Vector<ClassLoader>();
    protected static LoaderRepository instance = null;
    protected Translator translator = null;
 
    /** The loaded classes cache, HashMap<String, Class>.
     * Access synchronized via this.classes monitor.
     */
-   private ConcurrentReaderHashMap classes = new ConcurrentReaderHashMap();
+   private ConcurrentHashMap<String, Class<?>> classes = new ConcurrentHashMap<String, Class<?>>();
 
 
    /**
     * Native signature to class map
     */
-   private static HashMap nativeClassBySignature;
+   private static HashMap<String, Class<?>> nativeClassBySignature;
 
    // Static --------------------------------------------------------
    private static final Logger log = Logger.getLogger(LoaderRepository.class);
@@ -68,7 +66,7 @@
     */
    static
    {
-      nativeClassBySignature = new HashMap();
+      nativeClassBySignature = new HashMap<String, Class<?>>();
       nativeClassBySignature.put("boolean", boolean.class);
       nativeClassBySignature.put("byte", byte.class);
       nativeClassBySignature.put("char", char.class);
@@ -90,7 +88,7 @@
    }
 
    // Public --------------------------------------------------------
-   public Vector getLoaders()
+   public Vector<ClassLoader> getLoaders()
    {
       return loaders;
    }
@@ -100,9 +98,9 @@
       return null;
    }
 
-   public Class getCachedClass(String classname)
+   public Class<?> getCachedClass(String classname)
    {
-       return (Class)classes.get(classname);
+       return classes.get(classname);
    }
 
    public Translator getTranslator()
@@ -139,7 +137,7 @@
     * @return the found class
     * @exception ClassNotFoundException when there is no such class
     */
-   public abstract Class loadClass(String className) throws ClassNotFoundException;
+   public abstract Class<?> loadClass(String className) throws ClassNotFoundException;
 
    /**
     * Loads a class from the repository, excluding the given
@@ -150,7 +148,7 @@
     * @return the found class
     * @exception ClassNotFoundException when there is no such class
     */
-   public abstract Class loadClassWithout(ClassLoader loader, String className) throws ClassNotFoundException;
+   public abstract Class<?> loadClassWithout(ClassLoader loader, String className) throws ClassNotFoundException;
 
    /**
     * Loads a class from the repository, using the classloaders that were
@@ -165,7 +163,7 @@
     * @throws ClassNotFoundException if none of the consulted classloaders were
     *         able to load the requested class
     */
-   public abstract Class loadClassBefore(ClassLoader stop, String className) throws ClassNotFoundException;
+   public abstract Class<?> loadClassBefore(ClassLoader stop, String className) throws ClassNotFoundException;
 
    // END ClassLoaderRepository ****************************************************************************************
 
@@ -196,10 +194,10 @@
     * @param name
     * @param resolve
     * @param cl
-    * @return
+    * @return the class
     * @throws ClassNotFoundException
     */
-   public abstract Class loadClass(String name, boolean resolve, ClassLoader cl)
+   public abstract Class<?> loadClass(String name, boolean resolve, ClassLoader cl)
       throws ClassNotFoundException;
 
    /** Find a resource URL for the given name
@@ -217,9 +215,11 @@
     * @param cl the requesting class loader
     * @param urls a list into which the located resource URLs will be placed
     */
-   public abstract void getResources(String name, ClassLoader cl, List urls);
+   public abstract void getResources(String name, ClassLoader cl, List<URL> urls);
 
    /** Add a class loader to the repository
+    * 
+    * @param cl the classloader
     */
    public abstract void addClassLoader(ClassLoader cl);
    /** Update the set of URLs known to be associated with a previously added
@@ -227,6 +227,7 @@
     *
     * @param cl
     * @param url
+    * @return true if added
     */
    public abstract boolean addClassLoaderURL(ClassLoader cl, URL url);
    /** Remove a cladd loader from the repository.
@@ -236,12 +237,14 @@
 
    /**
     * Return the class of a java native type
+    * 
+    * @param className the className
     * @return the class, or null if className is not a native class name
     */
-   public static final Class getNativeClassForName(String className)
+   public static final Class<?> getNativeClassForName(String className)
    {
       // Check for native classes
-      return (Class)nativeClassBySignature.get(className);
+      return nativeClassBySignature.get(className);
    }
 
    /**
@@ -257,8 +260,12 @@
 
    /**
     * Add a class to the the cache
+    * 
+    * @param name the class name
+    * @param cls the class
+    * @param cl the classloader
     */
-   void cacheLoadedClass(String name, Class cls, ClassLoader cl)
+   void cacheLoadedClass(String name, Class<?> cls, ClassLoader cl)
    {
        synchronized( classes )
        {
diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/LoadMgr3.java trunk/org/jboss/mx/loading/LoadMgr3.java
--- 6.0.0.M1/org/jboss/mx/loading/LoadMgr3.java	2009-11-30 14:38:49.000000000 -0600
+++ trunk/org/jboss/mx/loading/LoadMgr3.java	2009-12-10 12:42:46.000000000 -0600
@@ -41,8 +41,9 @@
  * class loading tasks.
  *
  * @author Scott.Stark@jboss.org
- * @version $Revision: 93301 $
+ * @version $Revision: 85671 $
  */
+@SuppressWarnings("unchecked")
 public class LoadMgr3
 {
    private static Logger log = Logger.getLogger(LoadMgr3.class);
@@ -116,6 +117,9 @@
    /** Register that a thread owns the UCL3.loadClass monitor. This is called
     * from within UCL3.loadClass(String,boolean) and this method creates
     * entries in the loadClassThreads and loadTasksByThread maps.
+    * 
+    * @param ucl the classloader
+    * @param t the thread
     */
    public static void registerLoaderThread(RepositoryClassLoader ucl, Thread t)
    {
@@ -148,6 +152,8 @@
     * The ThreadTask are assigned to the threads that own the associated UCL3
     * monitor. If no class loader serves the class package, then the requesting
     * class loader is asked if it can load the class.
+    * @param task 
+    * @param repository 
     *
     * @return true if the class could be loaded from the cache or requesting
     * UCL3, false to indicate the calling thread must process the
@@ -335,6 +341,10 @@
     * to be involved. Any thread active in loadClass with the monitor held
     * processes class loading tasks that must be handled by its UCL3. The
     * active set of threads loading classes form a pool of cooperating threads.
+    * @param t 
+    * @param task 
+    * @param repository 
+    * @throws InterruptedException 
     */
    public static void nextTask(Thread t, ClassLoadingTask task,
       UnifiedLoaderRepository3 repository)
@@ -408,19 +418,18 @@
       }
       catch(Throwable e)
       {
-    	 log.trace("Class loading Task Run failed with exception", e);
     	 boolean retry = e instanceof ClassCircularityError
             || e.getClass().equals(LinkageError.class);
          int numCCE = loadTask.incNumCCE();
-         
          if( retry && numCCE <= 10 )
          {
-            log.info("Rescheduling failed Class loading Task");
         	/* Reschedule this task after all existing tasks to allow the
             current load tasks which are conflicting to complete.
             */
             try
             {
+               if( trace )
+                  log.trace("Run failed with exception", e);
                // Reschedule and update the loadTask.threadTaskCount
                scheduleTask(loadTask, ucl3, Integer.MAX_VALUE, true, trace);
             }
@@ -435,7 +444,8 @@
          else
          {
             loadTask.setLoadError(e);
-            log.warn("Not resheduling failed loading task, loadTask="+loadTask, e);
+            if( trace )
+               log.trace("Run failed with exception, loadTask="+loadTask, e);
          }
       }
       finally
@@ -495,6 +505,7 @@
 
    /** Complete a ClassLoadingTask. This is called by UCL3.loadClass to indicate
     * that the thread is existing the loadClass method.
+    * @param task 
     */
    public static void endLoadTask(ClassLoadingTask task)
    {
Only in 6.0.0.M1/org/jboss/mx/loading: MBeanElement.java
Only in 6.0.0.M1/org/jboss/mx/loading: MBeanFileParser.java
Only in 6.0.0.M1/org/jboss/mx/loading: MLetParser.java
diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/MLetRepositoryClassLoader.java trunk/org/jboss/mx/loading/MLetRepositoryClassLoader.java
--- 6.0.0.M1/org/jboss/mx/loading/MLetRepositoryClassLoader.java	2009-11-30 14:38:49.000000000 -0600
+++ trunk/org/jboss/mx/loading/MLetRepositoryClassLoader.java	2009-12-10 12:42:46.000000000 -0600
@@ -32,7 +32,7 @@
  * A RepositoryClassLoader that wraps an MLet.
  * 
  * @author <a href="adrian@jboss.com">Adrian Brock</a>
- * @version $Revision: 81022 $
+ * @version $Revision: 85671 $
  */
 class MLetRepositoryClassLoader extends RepositoryClassLoader
 {
@@ -53,8 +53,7 @@
    /**
     * Create a new LoaderRepositoryClassLoader
     * 
-    * @param urls the urls
-    * @param parent the parent classloader
+    * @param mlet the mlet
     */
    protected MLetRepositoryClassLoader(MLet mlet)
    {
@@ -95,7 +94,7 @@
       return repository.getURLs();
    }
    
-   public synchronized Class loadClassImpl(String name, boolean resolve, int stopAt)
+   public synchronized Class<?> loadClassImpl(String name, boolean resolve, int stopAt)
       throws ClassNotFoundException
    {
       loadClassDepth ++;
@@ -138,7 +137,7 @@
       {
          Thread t = Thread.currentThread();
          // Register this thread as owning this UCL
-         if( loadLock.holds() == 1 )
+         if( loadLock.getHoldCount() == 1 )
             LoadMgr3.registerLoaderThread(this, t);
 
          // Create a class loading task and submit it to the repository
@@ -166,7 +165,7 @@
       finally
       {
          // Unregister as the UCL owner to reschedule any remaining load tasks
-         if( loadLock.holds() == 1 )
+         if( loadLock.getHoldCount() == 1 )
             LoadMgr3.endLoadTask(task);
          // Notify any threads waiting to use this UCL
          this.release();
@@ -196,13 +195,13 @@
 
    // URLClassLoader overrides --------------------------------------
 
-   public Class loadClassLocally(String name, boolean resolve)
+   public Class<?> loadClassLocally(String name, boolean resolve)
       throws ClassNotFoundException
    {
       boolean trace = log.isTraceEnabled();
       if( trace )
          log.trace("loadClassLocally, " + this + " name=" + name);
-      Class result = null;
+      Class<?> result = null;
       try
       {
          result = mlet.loadClass(name, null);
